All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
5 mr - a Multiple Repository management tool
9 B<mr> [options] checkout
11 B<mr> [options] update
13 B<mr> [options] status
15 B<mr> [options] commit [-m "message"]
17 B<mr> [options] record [-m "message"]
25 B<mr> [options] run command [param ...]
27 B<mr> [options] bootstrap url [directory]
29 B<mr> [options] register [repository]
31 B<mr> [options] config section ["parameter=[value]" ...]
33 B<mr> [options] action [params ...]
35 B<mr> [options] [online|offline]
37 B<mr> [options] remember action [params ...]
41 B<mr> is a Multiple Repository management tool. It can checkout, update, or
42 perform other actions on a set of repositories as if they were one combined
43 repository. It supports any combination of subversion, git, cvs, mercurial,
44 bzr, darcs and fossil repositories, and support for other version
45 control systems can easily be added.
47 B<mr> cds into and operates on all registered repositories at or below your
48 working directory. Or, if you are in a subdirectory of a repository that
49 contains no other registered repositories, it will stay in that directory,
50 and work on only that repository,
52 B<mr> is configured by .mrconfig files, which list the repositories. It
53 starts by reading the .mrconfig file in your home directory, and this can
54 in turn chain load .mrconfig files from repositories. It also automatically
55 looks for a .mrconfig file in the current directory, or in one of its
58 These predefined commands should be fairly familiar to users of any version
63 =item checkout (or co)
65 Checks out any repositories that are not already checked out.
69 Updates each repository from its configured remote repository.
71 If a repository isn't checked out yet, it will first check it out.
75 Displays a status report for each repository, showing what
76 uncommitted changes are present in the repository.
80 Commits changes to each repository. (By default, changes are pushed to the
81 remote repository too, when using distributed systems like git. If you
82 don't like this default, you can change it in your .mrconfig, or use record
85 The optional -m parameter allows specifying a commit message.
89 Records changes to the local repository, but does not push them to the
90 remote repository. Only supported for distributed version control systems.
92 The optional -m parameter allows specifying a commit message.
96 Pushes committed local changes to the remote repository. A no-op for
97 centralized version control systems.
101 Show a diff of uncommitted changes.
107 =item run command [param ...]
109 Runs the specified command in each repository.
113 These commands are also available:
117 =item bootstrap url [directory]
119 Causes mr to download the url, and use it as a .mrconfig file
120 to checkout the repositories listed in it, into the specified directory.
122 The directory will be created if it does not exist. If no directory is
123 specified, the current directory will be used.
125 If the .mrconfig file includes a repository named ".", that
126 is checked out into the top of the specified directory.
130 List the repositories that mr will act on.
134 Register an existing repository in a mrconfig file. By default, the
135 repository in the current directory is registered, or you can specify a
136 directory to register.
138 The mrconfig file that is modified is chosen by either the -c option, or by
139 looking for the closest known one at or in a parent of the current directory.
143 Adds, modifies, removes, or prints a value from a mrconfig file. The next
144 parameter is the name of the section the value is in. To add or modify
145 values, use one or more instances of "parameter=value". Use "parameter=" to
146 remove a parameter. Use just "parameter" to get the value of a parameter.
148 For example, to add (or edit) a repository in src/foo:
150 mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
152 To show the command that mr uses to update the repository in src/foo:
154 mr config src/foo update
156 To see the built-in library of shell functions contained in mr:
158 mr config DEFAULT lib
160 The mrconfig file that is used is chosen by either the -c option, or by
161 looking for the closest known one at or in a parent of the current directory.
165 Advises mr that it is in offline mode. Any commands that fail in
166 offline mode will be remembered, and retried when mr is told it's online.
170 Advices mr that it is in online mode again. Commands that failed while in
171 offline mode will be re-run.
175 Remember a command, to be run later when mr re-enters online mode. This
176 implicitly puts mr into offline mode. The command can be any regular mr
177 command. This is useful when you know that a command will fail due to being
178 offline, and so don't want to run it right now at all, but just remember
179 to run it when you go back online.
187 Actions can be abbreviated to any unambiguous substring, so
188 "mr st" is equivalent to "mr status", and "mr up" is equivalent to "mr
191 Additional parameters can be passed to most commands, and are passed on
192 unchanged to the underlying version control system. This is mostly useful
193 if the repositories mr will act on all use the same version control
202 =item --directory directory
204 Specifies the topmost directory that B<mr> should work in. The default is
205 the current working directory.
209 =item --config mrconfig
211 Use the specified mrconfig file. The default is to use both F<~/.mrconfig>
212 as well as look for a F<.mrconfig> file in the current directory, or in one
213 of its parent directories.
225 Be quiet. This suppresses mr's usual output, as well as any output from
226 commands that are run (including stderr output). If a command fails,
227 the output will be shown.
233 Accept untrusted SSL certificates when bootstrapping.
239 Expand the statistics line displayed at the end to include information
240 about exactly which repositories failed and were skipped, if any.
246 Interactive mode. If a repository fails to be processed, a subshell will be
247 started which you can use to resolve or investigate the problem. Exit the
248 subshell to continue the mr run.
252 =item --no-recurse [number]
254 If no number if specified, just operate on the repository for the current
255 directory, do not recurse into deeper repositories.
257 If a number is specified, will recurse into repositories at most that many
258 subdirectories deep. For example, with -n 2 it would recurse into ./src/foo,
259 but not ./src/packages/bar.
263 =item --jobs [number]
265 Run the specified number of jobs in parallel, or an unlimited number of jobs
266 with no number specified. This can greatly speed up operations such as updates.
267 It is not recommended for interactive operations.
269 Note that running more than 10 jobs at a time is likely to run afoul of
270 ssh connection limits. Running between 3 and 5 jobs at a time will yield
271 a good speedup in updates without loading the machine too much.
277 Trust all mrconfig files even if they are not listed in F<~/.mrtrust>.
284 This obsolete flag is ignored.
288 =head1 MRCONFIG FILES
290 Here is an example F<.mrconfig> file:
293 checkout = svn checkout svn://svn.example.com/src/trunk src
297 checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
299 git checkout -b mybranch origin/master
301 The F<.mrconfig> file uses a variant of the INI file format. Lines
302 starting with "#" are comments. Values can be continued to the
303 following line by indenting the line with whitespace.
305 The C<DEFAULT> section allows setting default values for the sections that
308 The C<ALIAS> section allows adding aliases for actions. Each parameter
309 is an alias, and its value is the action to use.
311 All other sections add repositories. The section header specifies the
312 directory where the repository is located. This is relative to the directory
313 that contains the mrconfig file, but you can also choose to use absolute
314 paths. (Note that you can use environment variables in section names; they
315 will be passed through the shell for expansion. For example,
316 C<[$HOSTNAME]>, or C<[${HOSTNAME}foo]>).
318 Within a section, each parameter defines a shell command to run to handle a
319 given action. mr contains default handlers for "update", "status",
320 "commit", and other standard actions.
322 Normally you only need to specify what to do for "checkout". Here you
323 specify the command to run in order to create a checkout of the repository.
324 The command will be run in the parent directory, and must create the
325 repository's directory. So use C<git clone>, C<svn checkout>, C<bzr branch>
326 or C<bzr checkout> (for a bound branch), etc.
328 Note that these shell commands are run in a C<set -e> shell
329 environment, where any additional parameters you pass are available in
330 C<$@>. All commands other than "checkout" are run inside the repository,
331 though not necessarily at the top of it.
333 The C<MR_REPO> environment variable is set to the path to the top of the
334 repository. (For the "register" action, "MR_REPO" is instead set to the
335 basename of the directory that should be created when checking the
338 The C<MR_CONFIG> environment variable is set to the .mrconfig file
339 that defines the repo being acted on, or, if the repo is not yet in a config
340 file, the F<.mrconfig> file that should be modified to register the repo.
342 The C<MR_ACTION> environment variable is set to the command being run
343 (update, checkout, etc).
345 A few parameters have special meanings:
351 If the "skip" parameter is set and its command returns true, then B<mr>
352 will skip acting on that repository. The command is passed the action
355 Here are two examples. The first skips the repo unless
356 mr is run by joey. The second uses the hours_since function
357 (included in mr's built-in library) to skip updating the repo unless it's
358 been at least 12 hours since the last update.
362 skip = test `whoami` != joey
366 skip = [ "$1" = update ] && ! hours_since "$1" 12
368 Another way to use skip is for a lazy checkout. This makes mr skip
369 operating on a repo unless it already exists. To enable the
370 repo, you have to explicitly check it out (using "mr -d foo checkout").
378 The "order" parameter can be used to override the default ordering of
379 repositories. The default order value is 10. Use smaller values to make
380 repositories be processed earlier, and larger values to make repositories
383 Note that if a repository is located in a subdirectory of another
384 repository, ordering it to be processed earlier is not recommended.
388 If the "chain" parameter is set and its command returns true, then B<mr>
389 will try to load a F<.mrconfig> file from the root of the repository.
393 If the "include" parameter is set, its command is ran, and should output
394 additional mrconfig file content. The content is included as if it were
395 part of the including file.
397 Unlike all other parameters, this parameter does not need to be placed
400 B<mr> ships several libraries that can be included to add support for
401 additional version control type things (unison, git-svn, vcsh, git-fake-bare,
402 git-subtree). To include them all, you could use:
404 include = cat /usr/share/mr/*
406 See the individual files for details.
410 If the "deleted" parameter is set and its command returns true, then
411 B<mr> will treat the repository as deleted. It won't ever actually delete
412 the repository, but it will warn if it sees the repository's directory.
413 This is useful when one mrconfig file is shared among multiple machines,
414 to keep track of and remember to delete old repositories.
418 The "lib" parameter can specify some shell code that will be run before each
419 command, this can be a useful way to define shell functions for other commands
424 If the "fixups" parameter is set, its command is run whenever a repository
425 is checked out, or updated. This provides an easy way to do things
426 like permissions fixups, or other tweaks to the repository content,
427 whenever the repository is changed.
431 If a "pre_action" parameter is set, its command is run before mr performs the
432 specified action. Similarly, "post_action" parameters are run after mr
433 successfully performs the specified action. For example, "pre_commit" is
434 run before committing; "post_update" is run after updating.
438 When looking for a command to run for a given action, mr first looks for
439 a parameter with the same name as the action. If that is not found, it
440 looks for a parameter named "VCS_action" (substituting in the name of the
441 version control system and the action). The name of the version control
442 system is itself determined by running each defined "VCS_test" action,
445 Internally, mr has settings for "git_update", "svn_update", etc. To change
446 the action that is performed for a given version control system, you can
447 override these VCS specific actions. To add a new version control system,
448 you can just add VCS specific actions for it.
450 =head1 UNTRUSTED MRCONFIG FILES
452 Since mrconfig files can contain arbitrary shell commands, they can do
453 anything. This flexibility is good, but it also allows a malicious mrconfig
454 file to delete your whole home directory. Such a file might be contained
455 inside a repository that your main F<~/.mrconfig> checks out. To
456 avoid worries about evil commands in a mrconfig file, mr defaults to
457 reading all mrconfig files other than the main F<~/.mrconfig> in untrusted
458 mode. In untrusted mode, mrconfig files are limited to running only known
459 safe commands (like "git clone") in a carefully checked manner.
461 To configure mr to trust other mrconfig files, list them in F<~/.mrtrust>.
462 One mrconfig file should be listed per line. Either the full pathname
463 should be listed, or the pathname can start with F<~/> to specify a file
464 relative to your home directory.
466 =head1 OFFLINE LOG FILE
468 The F<~/.mrlog> file contains commands that mr has remembered to run later,
469 due to being offline. You can delete or edit this file to remove commands,
470 or even to add other commands for 'mr online' to run. If the file is
471 present, mr assumes it is in offline mode.
475 mr can be extended to support things such as unison and git-svn. Some
476 files providing such extensions are available in F</usr/share/mr/>. See
477 the documentation in the files for details about using them.
481 mr returns nonzero if a command failed in any of the repositories.
485 Copyright 2007-2011 Joey Hess <joey@kitenet.net>
487 Licensed under the GNU GPL version 2 or higher.
489 http://kitenet.net/~joey/code/mr/
496 use Cwd qw(getcwd abs_path);
498 # things that can happen when mr runs a command
507 my $config_overridden=0;
517 my $directory=getcwd();
519 $ENV{MR_CONFIG}=find_mrconfig();
526 my (@ok, @failed, @skipped);
532 my ($action, $dir, $topdir, $subdir) = @_;
534 if (exists $vcs{$dir}) {
539 foreach my $vcs_test (
541 length $a <=> length $b
544 } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
545 my ($vcs)=$vcs_test=~/(.*)_test/;
546 $test="my_$vcs_test() {\n$config{$topdir}{$subdir}{$vcs_test}\n}\n".$test;
547 $test.="if my_$vcs_test; then echo $vcs; fi\n";
549 $test=$config{$topdir}{$subdir}{lib}."\n".$test
550 if exists $config{$topdir}{$subdir}{lib};
552 print "mr $action: running vcs test >>$test<<\n" if $verbose;
557 print STDERR "mr $action: found multiple possible repository types ($vcs) for ".fulldir($topdir, $subdir)."\n";
561 return $vcs{$dir}=undef;
564 return $vcs{$dir}=$vcs;
569 my ($action, $dir, $topdir, $subdir, $is_checkout) = @_;
571 if (exists $config{$topdir}{$subdir}{$action}) {
572 return $config{$topdir}{$subdir}{$action};
579 my $vcs=vcs_test(@_);
582 exists $config{$topdir}{$subdir}{$vcs."_".$action}) {
583 return $config{$topdir}{$subdir}{$vcs."_".$action};
591 my ($topdir, $subdir) = @_;
592 return $subdir =~ /^\// ? $subdir : $topdir.$subdir;
596 my ($action, $dir, $topdir, $subdir, $force_checkout) = @_;
597 my $fulldir=fulldir($topdir, $subdir);
599 $ENV{MR_CONFIG}=$configfiles{$topdir};
600 my $lib=exists $config{$topdir}{$subdir}{lib} ?
601 $config{$topdir}{$subdir}{lib}."\n" : "";
602 my $is_checkout=($action eq 'checkout');
603 my $is_update=($action =~ /update/);
605 ($ENV{MR_REPO}=$dir) =~ s!/$!!;
606 $ENV{MR_ACTION}=$action;
608 foreach my $testname ("skip", "deleted") {
609 my $testcommand=findcommand($testname, $dir, $topdir, $subdir, $is_checkout);
611 if (defined $testcommand) {
612 my $test="set -e;".$lib.
613 "my_action(){ $testcommand\n }; my_action '$action'";
614 print "mr $action: running $testname test >>$test<<\n" if $verbose;
615 my $ret=system($test);
617 if (($? & 127) == 2) {
618 print STDERR "mr $action: interrupted\n";
622 print STDERR "mr $action: $testname test received signal ".($? & 127)."\n";
626 if ($ret >> 8 == 0) {
627 if ($testname eq "deleted") {
629 print STDERR "mr error: $dir should be deleted yet still exists\n";
633 print "mr $action: skip $dir skipped\n" if $verbose;
640 if (! $force_checkout) {
642 print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
646 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
651 return action("checkout", $dir, $topdir, $subdir);
655 my $command=findcommand($action, $dir, $topdir, $subdir, $is_checkout);
657 if ($is_checkout && ! -d $dir) {
658 print "mr $action: creating parent directory $dir\n" if $verbose;
659 system("mkdir", "-p", $dir);
662 if (! $no_chdir && ! chdir($dir)) {
663 print STDERR "mr $action: failed to chdir to $dir: $!\n";
666 elsif (! defined $command) {
667 my $vcs=vcs_test(@_);
668 if (! defined $vcs) {
669 print STDERR "mr $action: unknown repository type and no defined $action command for $fulldir\n";
673 print STDERR "mr $action: no defined action for $vcs repository $fulldir, skipping\n";
680 $actionmsg="mr $action: $fulldir";
684 $s=~s/^\Q$fulldir\E\/?//;
685 $actionmsg="mr $action: $fulldir (in subdir $s)";
687 print "$actionmsg\n" unless $quiet;
689 my $hookret=hook("pre_$action", $topdir, $subdir);
690 return $hookret if $hookret != OK;
692 $command="set -e; ".$lib.
693 "my_action(){ $command\n }; my_action ".
694 join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
695 print "mr $action: running >>$command<<\n" if $verbose;
698 my $output = qx/$command 2>&1/;
701 print "$actionmsg\n";
702 print STDERR $output;
706 $ret=system($command);
709 if (($? & 127) == 2) {
710 print STDERR "mr $action: interrupted\n";
714 print STDERR "mr $action: received signal ".($? & 127)."\n";
717 print STDERR "mr $action: failed ($ret)\n" if $verbose;
718 if ($ret >> 8 != 0) {
719 print STDERR "mr $action: command failed\n";
720 if (-e "$ENV{HOME}/.mrlog" && $action ne 'remember') {
721 # recreate original command line to
722 # remember, and avoid recursing
724 @ARGV=('-n', $action, @orig);
725 action("remember", $dir, $topdir, $subdir);
730 print STDERR "mr $action: command died ($ret)\n";
735 if ($is_checkout && ! -d $dir) {
736 print STDERR "mr $action: $dir missing after checkout\n";;
740 my $ret=hook("post_$action", $topdir, $subdir);
741 return $ret if $ret != OK;
743 if (($is_checkout || $is_update)) {
744 my $ret=hook("fixups", $topdir, $subdir);
745 return $ret if $ret != OK;
754 my ($hook, $topdir, $subdir) = @_;
756 my $command=$config{$topdir}{$subdir}{$hook};
757 return OK unless defined $command;
758 my $lib=exists $config{$topdir}{$subdir}{lib} ?
759 $config{$topdir}{$subdir}{lib}."\n" : "";
760 my $shell="set -e;".$lib.
761 "my_hook(){ $command\n }; my_hook";
762 print "mr $hook: running >>$shell<<\n" if $verbose;
765 my $output = qx/$shell 2>&1/;
768 print STDERR $output;
775 if (($? & 127) == 2) {
776 print STDERR "mr $hook: interrupted\n";
780 print STDERR "mr $hook: received signal ".($? & 127)."\n";
791 # run actions on multiple repos, in parallel
801 while (@fhs or @repos) {
802 while ((!$jobs || $running < $jobs) && @repos) {
804 my $repo = shift @repos;
805 pipe(my $outfh, CHILD_STDOUT);
806 pipe(my $errfh, CHILD_STDERR);
808 unless ($pid = fork) {
809 die "mr $action: cannot fork: $!" unless defined $pid;
810 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
811 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
816 exit action($action, @$repo);
820 push @active, [$pid, $repo];
821 push @fhs, [$outfh, $errfh];
824 my ($rin, $rout) = ('','');
826 foreach my $fh (@fhs) {
827 next unless defined $fh;
828 vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
829 vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
831 $nfound = select($rout=$rin, undef, undef, 1);
832 foreach my $channel (0, 1) {
833 foreach my $i (0..$#fhs) {
834 next unless defined $fhs[$i];
835 my $fh = $fhs[$i][$channel];
836 next unless defined $fh;
837 if (vec($rout, fileno($fh), 1) == 1) {
839 if (sysread($fh, $r, 1024) == 0) {
841 $fhs[$i][$channel] = undef;
842 if (! defined $fhs[$i][0] &&
843 ! defined $fhs[$i][1]) {
844 waitpid($active[$i][0], 0);
845 print STDOUT $out[$i][0];
846 print STDERR $out[$i][1];
847 record($active[$i][1], $? >> 8);
849 splice(@active, $i, 1);
854 $out[$i][$channel] .= $r;
862 my $dir=shift()->[0];
867 print "\n" unless $quiet;
869 elsif ($ret == FAILED) {
871 chdir($dir) unless $no_chdir;
872 print STDERR "mr: Starting interactive shell. Exit shell to continue.\n";
873 system((getpwuid($<))[8], "-i");
876 print "\n" unless $quiet;
878 elsif ($ret == SKIPPED) {
881 elsif ($ret == ABORT) {
885 die "unknown exit status $ret";
891 if (! @ok && ! @failed && ! @skipped) {
892 die "mr $action: no repositories found to work on\n";
894 print "mr $action: finished (".join("; ",
895 showstat($#ok+1, "ok", "ok"),
896 showstat($#failed+1, "failed", "failed"),
897 showstat($#skipped+1, "skipped", "skipped"),
898 ).")\n" unless $quiet;
901 print "mr $action: (skipped: ".join(" ", @skipped).")\n" unless $quiet;
904 print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
914 return "$count ".($count > 1 ? $plural : $singular);
919 # an ordered list of repos
922 foreach my $topdir (sort keys %config) {
923 foreach my $subdir (sort keys %{$config{$topdir}}) {
927 order => $config{$topdir}{$subdir}{order},
932 $a->{order} <=> $b->{order}
934 $a->{topdir} cmp $b->{topdir}
936 $a->{subdir} cmp $b->{subdir}
942 my $topdir=$repo->{topdir};
943 my $subdir=$repo->{subdir};
944 my $ret=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
949 # Figure out which repos to act on. Returns a list of array refs
952 # [ "$full_repo_path/", "$mr_config_path/", $section_header ]
955 foreach my $repo (repolist()) {
956 my $topdir=$repo->{topdir};
957 my $subdir=$repo->{subdir};
959 next if $subdir eq 'DEFAULT';
960 my $dir=repodir($repo);
962 $dir.="/" unless $dir=~/\/$/;
963 $d.="/" unless $d=~/\/$/;
964 next if $dir ne $d && $dir !~ /^\Q$d\E/;
965 if (defined $max_depth) {
966 my @a=split('/', $dir);
967 my @b=split('/', $d);
968 do { } while (@a && @b && shift(@a) eq shift(@b));
969 next if @a > $max_depth || @b > $max_depth;
971 push @repos, [$dir, $topdir, $subdir];
974 # fallback to find a leaf repo
975 foreach my $repo (reverse repolist()) {
976 my $topdir=$repo->{topdir};
977 my $subdir=$repo->{subdir};
979 next if $subdir eq 'DEFAULT';
980 my $dir=repodir($repo);
982 $dir.="/" unless $dir=~/\/$/;
983 $d.="/" unless $d=~/\/$/;
984 if ($d=~/^\Q$dir\E/) {
985 push @repos, [$dir, $topdir, $subdir];
1007 sub is_trusted_config {
1008 my $config=shift; # must be abs_pathed already
1010 # We always trust ~/.mrconfig.
1011 return 1 if $config eq abs_path("$ENV{HOME}/.mrconfig");
1013 return 1 if $trust_all;
1015 my $trustfile=$ENV{HOME}."/.mrtrust";
1018 $trusted{"$ENV{HOME}/.mrconfig"}=1;
1019 if (open (TRUST, "<", $trustfile)) {
1022 s/^~\//$ENV{HOME}\//;
1023 $trusted{abs_path($_)}=1;
1029 return $trusted{$config};
1033 sub is_trusted_repo {
1036 # Tightly limit what is allowed in a repo name.
1037 # No ../, no absolute paths, and no unusual filenames
1038 # that might try to escape to the shell.
1039 return $repo =~ /^[-_.+\/A-Za-z0-9]+$/ &&
1040 $repo !~ /\.\./ && $repo !~ /^\//;
1043 sub is_trusted_checkout {
1046 # To determine if the command is safe, compare it with the
1047 # *_trusted_checkout config settings. Those settings are
1048 # templates for allowed commands, so make sure that each word
1049 # of the command matches the corresponding word of the template.
1052 foreach my $word (split(' ', $command)) {
1054 if ($word=~/^'(.*)'$/) {
1057 elsif ($word=~/^"(.*)"$/) {
1064 foreach my $key (grep { /_trusted_checkout$/ }
1065 keys %{$config{''}{DEFAULT}}) {
1066 my @twords=split(' ', $config{''}{DEFAULT}{$key});
1067 next if @words > @twords;
1071 for (my $c=0; $c < @twords && $match; $c++) {
1072 if ($twords[$c] eq '$url') {
1073 # Match all the typical characters found in
1074 # urls, plus @ which svn can use. Note
1075 # that the "url" might also be a local
1078 defined $words[$c] &&
1079 $words[$c] =~ /^[-_.+:@\/A-Za-z0-9]+$/
1083 elsif ($twords[$c] eq '$repo') {
1084 # If a repo is not specified, assume it
1085 # will be the last path component of the
1086 # url, or something derived from it, and
1088 if (! defined $words[$c] && defined $url) {
1089 ($words[$c])=$url=~/\/([^\/]+)\/?$/;
1093 defined $words[$c] &&
1094 is_trusted_repo($words[$c])
1097 elsif (defined $words[$c] && $words[$c]=~/^($twords[$c])$/) {
1111 my ($err, $file, $line, $url)=@_;
1114 die "$err in untrusted $url line $line\n".
1115 "(To trust this url, --trust-all can be used; but please use caution;\n".
1116 "this can allow arbitrary code execution!)\n";
1119 die "$err in untrusted $file line $line\n".
1120 "(To trust this file, list it in ~/.mrtrust.)\n";
1128 my $bootstrap_url=shift;
1134 if (ref $f eq 'GLOB') {
1140 my $absf=abs_path($f);
1141 if ($loaded{$absf}) {
1146 $trusted=is_trusted_config($absf);
1148 if (! defined $dir) {
1149 ($dir)=$f=~/^(.*\/)[^\/]+$/;
1150 if (! defined $dir) {
1155 $dir=abs_path($dir)."/";
1157 if (! exists $configfiles{$dir}) {
1158 $configfiles{$dir}=$f;
1161 # copy in defaults from first parent
1163 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
1164 if ($parent eq '/') {
1167 if (exists $config{$parent} &&
1168 exists $config{$parent}{DEFAULT}) {
1169 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
1178 print "mr: loading config $f\n" if $verbose;
1179 open($in, "<", $f) || die "mr: open $f: $!\n";
1182 close $in unless ref $f eq 'GLOB';
1186 # Keep track of the current line in the config file;
1187 # when a file is included track the current line from the include.
1191 my $nextline = sub {
1205 my $lineerror = sub {
1207 if (defined $included) {
1208 die "mr: $f line $line include line $includeline: $msg\n";
1211 die "mr: $f line $line: $msg\n";
1218 if (! $trusted && /[[:cntrl:]]/) {
1219 trusterror("mr: illegal control character", $f, $line, $bootstrap_url);
1222 next if /^\s*\#/ || /^\s*$/;
1223 if (/^\[([^\]]*)\]\s*$/) {
1227 if (! is_trusted_repo($section) ||
1228 $section eq 'ALIAS' ||
1229 $section eq 'DEFAULT') {
1230 trusterror("mr: illegal section \"[$section]\"", $f, $line, $bootstrap_url)
1233 $section=expandenv($section) if $trusted;
1234 if ($section ne 'ALIAS' &&
1235 ! exists $config{$dir}{$section} &&
1236 exists $config{$dir}{DEFAULT}) {
1238 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
1241 elsif (/^(\w+)\s*=\s*(.*)/) {
1246 while (@lines && $lines[0]=~/^\s(.+)/) {
1253 # Untrusted files can only contain a few
1254 # settings in specific known-safe formats.
1255 if ($parameter eq 'checkout') {
1256 if (! is_trusted_checkout($value)) {
1257 trusterror("mr: illegal checkout command \"$value\"", $f, $line, $bootstrap_url);
1260 elsif ($parameter eq 'order') {
1261 # not interpreted as a command, so
1264 elsif ($value eq 'true' || $value eq 'false') {
1265 # skip=true , deleted=true etc are
1269 trusterror("mr: illegal setting \"$parameter=$value\"", $f, $line, $bootstrap_url);
1273 if ($parameter eq "include") {
1274 print "mr: including output of \"$value\"\n" if $verbose;
1277 print STDERR "mr: include command exited nonzero ($?)\n";
1280 unshift @lines, @inc;
1284 if (! defined $section) {
1285 $lineerror->("parameter ($parameter) not in section");
1287 if ($section eq 'ALIAS') {
1288 $alias{$parameter}=$value;
1290 elsif ($parameter eq 'lib') {
1291 $config{$dir}{$section}{lib}.=$value."\n";
1294 $config{$dir}{$section}{$parameter}=$value;
1295 if ($parameter =~ /.*_(.*)/) {
1296 $knownactions{$1}=1;
1299 $knownactions{$parameter}=1;
1301 if ($parameter eq 'chain' &&
1302 length $dir && $section ne "DEFAULT") {
1303 my $chaindir="$section";
1304 if ($chaindir !~ m!^/!) {
1305 $chaindir=$dir.$chaindir;
1307 if (-e "$chaindir/.mrconfig") {
1308 my $ret=system($value);
1310 if (($? & 127) == 2) {
1311 print STDERR "mr: chain test interrupted\n";
1315 print STDERR "mr: chain test received signal ".($? & 127)."\n";
1319 push @toload, ["$chaindir/.mrconfig", $chaindir];
1326 $lineerror->("parse error");
1330 foreach my $c (@toload) {
1335 sub startingconfig {
1336 %alias=%config=%configfiles=%knownactions=%loaded=();
1337 my $datapos=tell(DATA);
1339 seek(DATA,$datapos,0); # rewind
1344 # the section to modify or add
1345 my $targetsection=shift;
1346 # fields to change in the section
1347 # To remove a field, set its value to "".
1348 my %changefields=@_;
1354 open(my $in, "<", $f) || die "mr: open $f: $!\n";
1359 my $formatfield=sub {
1361 my @value=split(/\n/, shift);
1363 return "$field = ".shift(@value)."\n".
1364 join("", map { "\t$_\n" } @value);
1368 while ($out[$#out] =~ /^\s*$/) {
1369 unshift @blanks, pop @out;
1371 foreach my $field (sort keys %changefields) {
1372 if (length $changefields{$field}) {
1373 push @out, "$field = $changefields{$field}\n";
1374 delete $changefields{$field};
1384 if (/^\s*\#/ || /^\s*$/) {
1387 elsif (/^\[([^\]]*)\]\s*$/) {
1388 if (defined $section &&
1389 $section eq $targetsection) {
1393 $section=expandenv($1);
1397 elsif (/^(\w+)\s*=\s(.*)/) {
1402 while (@lines && $lines[0]=~/^\s(.+)/) {
1408 if ($section eq $targetsection) {
1409 if (exists $changefields{$parameter}) {
1410 if (length $changefields{$parameter}) {
1411 $value=$changefields{$parameter};
1413 delete $changefields{$parameter};
1417 push @out, $formatfield->($parameter, $value);
1421 if (defined $section &&
1422 $section eq $targetsection) {
1425 elsif (%changefields) {
1426 push @out, "\n[$targetsection]\n";
1427 foreach my $field (sort keys %changefields) {
1428 if (length $changefields{$field}) {
1429 push @out, $formatfield->($field, $changefields{$field});
1434 open(my $out, ">", $f) || die "mr: write $f: $!\n";
1442 # actions that do not operate on all repos
1443 if ($action eq 'help') {
1446 elsif ($action eq 'config') {
1449 elsif ($action eq 'register') {
1452 elsif ($action eq 'bootstrap') {
1455 elsif ($action eq 'remember' ||
1456 $action eq 'offline' ||
1457 $action eq 'online') {
1458 my @repos=selectrepos;
1459 action($action, @{$repos[0]}) if @repos;
1463 if (!$jobs || $jobs > 1) {
1464 mrs($action, selectrepos());
1467 foreach my $repo (selectrepos()) {
1468 record($repo, action($action, @$repo));
1474 exec($config{''}{DEFAULT}{help}) || die "exec: $!";
1479 die "mr config: not enough parameters\n";
1482 if ($section=~/^\//) {
1483 # try to convert to a path relative to the config file
1484 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
1485 $dir=abs_path($dir);
1486 $dir.="/" unless $dir=~/\/$/;
1487 if ($section=~/^\Q$dir\E(.*)/) {
1493 if (/^([^=]+)=(.*)$/) {
1494 $changefields{$1}=$2;
1498 foreach my $topdir (sort keys %config) {
1499 if (exists $config{$topdir}{$section} &&
1500 exists $config{$topdir}{$section}{$_}) {
1501 print $config{$topdir}{$section}{$_}."\n";
1503 last if $section eq 'DEFAULT';
1507 die "mr config: $section $_ not set\n";
1511 modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
1516 if ($config_overridden) {
1517 # Find the directory that the specified config file is
1519 ($directory)=abs_path($ENV{MR_CONFIG})=~/^(.*\/)[^\/]+$/;
1522 # Find the closest known mrconfig file to the current
1524 $directory.="/" unless $directory=~/\/$/;
1526 foreach my $topdir (reverse sort keys %config) {
1527 next unless length $topdir;
1528 if ($directory=~/^\Q$topdir\E/) {
1529 $ENV{MR_CONFIG}=$configfiles{$topdir};
1535 if (! $foundconfig) {
1536 $directory=""; # no config file, use builtin
1540 my $subdir=shift @ARGV;
1541 if (! chdir($subdir)) {
1542 print STDERR "mr register: failed to chdir to $subdir: $!\n";
1546 $ENV{MR_REPO}=getcwd();
1547 my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT', 0);
1548 if (! defined $command) {
1549 die "mr register: unknown repository type\n";
1552 $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
1553 $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
1554 "my_action(){ $command\n }; my_action ".
1555 join(" ", map { s/\\/\\\\/g; s/"/\"/g; '"'.$_.'"' } @ARGV);
1556 print "mr register: running >>$command<<\n" if $verbose;
1557 exec($command) || die "exec: $!";
1561 my $url=shift @ARGV;
1562 my $dir=shift @ARGV || ".";
1564 if (! defined $url || ! length $url) {
1565 die "mr: bootstrap requires url\n";
1568 # Download the config file to a temporary location.
1569 eval q{use File::Temp};
1571 my $tmpconfig=File::Temp->new();
1572 my @curlargs = ("curl", "-A", "mr", "-L", "-s", $url, "-o", $tmpconfig);
1573 push(@curlargs, "-k") if $insecure;
1574 my $curlstatus = system(@curlargs);
1575 die "mr bootstrap: invalid SSL certificate for $url (consider -k)\n" if $curlstatus >> 8 == 60;
1576 die "mr bootstrap: download of $url failed\n" if $curlstatus != 0;
1579 system("mkdir", "-p", $dir);
1581 chdir($dir) || die "chdir $dir: $!";
1583 # Special case to handle checkout of the "." repo, which
1584 # would normally be skipped.
1585 my $topdir=abs_path(".")."/";
1586 my @repo=($topdir, $topdir, ".");
1587 loadconfig($tmpconfig, $topdir, $url);
1588 record(\@repo, action("checkout", @repo, 1))
1589 if exists $config{$topdir}{"."}{"checkout"};
1591 if (-e ".mrconfig") {
1592 print STDERR "mr bootstrap: .mrconfig file already exists, not overwriting with $url\n";
1595 eval q{use File::Copy};
1597 move($tmpconfig, ".mrconfig") || die "rename: $!";
1600 # Reload the config file (in case we got a different version)
1601 # and checkout everything else.
1603 loadconfig(".mrconfig");
1604 dispatch("checkout");
1605 @skipped=grep { abs_path($_) ne abs_path($topdir) } @skipped;
1606 showstats("bootstrap");
1610 # alias expansion and command stemming
1613 if (exists $alias{$action}) {
1614 $action=$alias{$action};
1616 if (! exists $knownactions{$action}) {
1617 my @matches = grep { /^\Q$action\E/ }
1618 keys %knownactions, keys %alias;
1619 if (@matches == 1) {
1620 $action=$matches[0];
1622 elsif (@matches == 0) {
1623 die "mr: unknown action \"$action\" (known actions: ".
1624 join(", ", sort keys %knownactions).")\n";
1627 die "mr: ambiguous action \"$action\" (matches: ".
1628 join(", ", @matches).")\n";
1636 while (length $dir) {
1637 if (-e "$dir/.mrconfig") {
1638 return "$dir/.mrconfig";
1640 $dir=~s/\/[^\/]*$//;
1642 return "$ENV{HOME}/.mrconfig";
1647 Getopt::Long::Configure("bundling", "no_permute");
1648 my $result=GetOptions(
1649 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1650 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1651 "p|path" => sub { }, # now default, ignore
1652 "v|verbose" => \$verbose,
1653 "q|quiet" => \$quiet,
1654 "s|stats" => \$stats,
1655 "k|insecure" => \$insecure,
1656 "i|interactive" => \$interactive,
1657 "n|no-recurse:i" => \$max_depth,
1658 "j|jobs:i" => \$jobs,
1659 "t|trust-all" => \$trust_all,
1661 if (! $result || @ARGV < 1) {
1662 die("Usage: mr [options] action [params ...]\n".
1663 "(Use mr help for man page.)\n");
1666 $ENV{MR_SWITCHES}="";
1667 foreach my $option (@saved) {
1668 last if $option eq $ARGV[0];
1669 $ENV{MR_SWITCHES}.="$option ";
1675 print STDERR "mr: interrupted\n";
1679 # This can happen if it's run in a directory that was removed
1680 # or other strangeness.
1681 if (! defined $directory) {
1682 die("mr: failed to determine working directory\n");
1684 # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1685 # the config file might be a symlink to elsewhere, and the directory it's
1686 # in is significant.
1687 if ($ENV{MR_CONFIG} !~ /^\//) {
1688 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1690 # Try to set MR_PATH to the path to the program.
1692 use FindBin qw($Bin $Script);
1693 $ENV{MR_PATH}=$Bin."/".$Script;
1711 loadconfig("$ENV{HOME}/.mrconfig");
1712 loadconfig($ENV{MR_CONFIG});
1713 #use Data::Dumper; print Dumper(\%config);
1715 my $action=expandaction(shift @ARGV);
1722 # Finally, some useful actions that mr knows about by default.
1723 # These can be overridden in ~/.mrconfig.
1738 echo "mr (warning): $@" >&2
1744 if [ -z "$1" ] || [ -z "$2" ]; then
1745 error "mr: usage: hours_since action num"
1747 for dir in .git .svn .bzr CVS .hg _darcs _FOSSIL_; do
1748 if [ -e "$MR_REPO/$dir" ]; then
1749 flagfile="$MR_REPO/$dir/.mr_last$1"
1753 if [ -z "$flagfile" ]; then
1754 error "cannot determine flag filename"
1756 delta=`perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile"`
1757 if [ "$delta" -lt "$2" ]; then
1765 LANG=C bzr info | egrep -q '^Checkout'
1768 if [ "$MR_ACTION" = checkout ] || [ -d "$MR_REPO" ]; then
1775 svn_test = test -d "$MR_REPO"/.svn
1776 git_test = test -d "$MR_REPO"/.git
1777 bzr_test = test -d "$MR_REPO"/.bzr
1778 cvs_test = test -d "$MR_REPO"/CVS
1779 hg_test = test -d "$MR_REPO"/.hg
1780 darcs_test = test -d "$MR_REPO"/_darcs
1781 fossil_test = test -f "$MR_REPO"/_FOSSIL_
1783 test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1784 test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1785 test "`GIT_CONFIG="$MR_REPO"/config git config --get core.bare`" = true
1787 svn_update = svn update "$@"
1788 git_update = git pull "$@"
1790 if is_bzr_checkout; then
1793 bzr merge --pull "$@"
1795 cvs_update = cvs update "$@"
1796 hg_update = hg pull "$@" && hg update "$@"
1797 darcs_update = darcs pull -a "$@"
1798 fossil_update = fossil pull "$@"
1800 svn_status = svn status "$@"
1801 git_status = git status -s "$@" || true
1802 bzr_status = bzr status --short "$@"
1803 cvs_status = cvs status "$@"
1804 hg_status = hg status "$@"
1805 darcs_status = darcs whatsnew -ls "$@" || true
1806 fossil_status = fossil changes "$@"
1808 svn_commit = svn commit "$@"
1809 git_commit = git commit -a "$@" && git push --all
1811 if is_bzr_checkout; then
1814 bzr commit "$@" && bzr push
1816 cvs_commit = cvs commit "$@"
1817 hg_commit = hg commit -m "$@" && hg push
1818 darcs_commit = darcs record -a -m "$@" && darcs push -a
1819 fossil_commit = fossil commit "$@"
1821 git_record = git commit -a "$@"
1823 if is_bzr_checkout; then
1824 bzr commit --local "$@"
1828 hg_record = hg commit -m "$@"
1829 darcs_record = darcs record -a -m "$@"
1830 fossil_record = fossil commit "$@"
1833 git_push = git push "$@"
1834 bzr_push = bzr push "$@"
1836 hg_push = hg push "$@"
1837 darcs_push = darcs push -a "$@"
1838 fossil_push = fossil push "$@"
1840 svn_diff = svn diff "$@"
1841 git_diff = git diff "$@"
1842 bzr_diff = bzr diff "$@"
1843 cvs_diff = cvs diff "$@"
1844 hg_diff = hg diff "$@"
1845 darcs_diff = darcs diff -u "$@"
1846 fossil_diff = fossil diff "$@"
1848 svn_log = svn log "$@"
1849 git_log = git log "$@"
1850 bzr_log = bzr log "$@"
1851 cvs_log = cvs log "$@"
1852 hg_log = hg log "$@"
1853 darcs_log = darcs changes "$@"
1854 git_bare_log = git log "$@"
1855 fossil_log = fossil timeline "$@"
1860 url=`LC_ALL=C svn info . | grep -i '^URL:' | cut -d ' ' -f 2`
1861 if [ -z "$url" ]; then
1862 error "cannot determine svn url"
1864 echo "Registering svn url: $url in $MR_CONFIG"
1865 mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1867 url="`LC_ALL=C git config --get remote.origin.url`" || true
1868 if [ -z "$url" ]; then
1869 error "cannot determine git url"
1871 echo "Registering git url: $url in $MR_CONFIG"
1872 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1874 url="`LC_ALL=C bzr info . | egrep -i 'checkout of branch|parent branch' | awk '{print $NF}'`"
1875 if [ -z "$url" ]; then
1876 error "cannot determine bzr url"
1878 echo "Registering bzr url: $url in $MR_CONFIG"
1879 mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr branch '$url' '$MR_REPO'"
1881 repo=`cat CVS/Repository`
1883 if [ -z "$root" ]; then
1884 error "cannot determine cvs root"
1886 echo "Registering cvs repository $repo at root $root"
1887 mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1889 url=`hg showconfig paths.default`
1890 echo "Registering mercurial repo url: $url in $MR_CONFIG"
1891 mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1893 url=`cat _darcs/prefs/defaultrepo`
1894 echo "Registering darcs repository $url in $MR_CONFIG"
1895 mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url' '$MR_REPO'"
1897 url="`LC_ALL=C GIT_CONFIG=config git config --get remote.origin.url`" || true
1898 if [ -z "$url" ]; then
1899 error "cannot determine git url"
1901 echo "Registering git url: $url in $MR_CONFIG"
1902 mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1904 url=`fossil remote-url`
1905 repo=`fossil info | grep repository | sed -e 's/repository:*.//g' -e 's/ //g'`
1906 echo "Registering fossil repository $url in $MR_CONFIG"
1907 mr -c "$MR_CONFIG" config "`pwd`" checkout="mkdir -p '$MR_REPO' && cd '$MR_REPO' && fossil open '$repo'"
1909 svn_trusted_checkout = svn co $url $repo
1910 svn_alt_trusted_checkout = svn checkout $url $repo
1911 git_trusted_checkout = git clone $url $repo
1912 bzr_trusted_checkout = bzr checkout|clone|branch|get $url $repo
1914 hg_trusted_checkout = hg clone $url $repo
1915 darcs_trusted_checkout = darcs get $url $repo
1916 git_bare_trusted_checkout = git clone --bare $url $repo
1917 # fossil: messy to do
1923 SHOWMANFILE="man -f"
1929 SHOWMANFILE="man -l"
1932 if [ ! -e "$MR_PATH" ]; then
1933 error "cannot find program path"
1935 tmp=$(mktemp -t mr.XXXXXXXXXX) || error "mktemp failed"
1936 trap "rm -f $tmp" exit
1937 pod2man -c mr "$MR_PATH" > "$tmp" || error "pod2man failed"
1938 $SHOWMANFILE "$tmp" || error "man failed"
1944 if [ -s ~/.mrlog ]; then
1945 info "running offline commands"
1946 mv -f ~/.mrlog ~/.mrlog.old
1947 if ! sh -e ~/.mrlog.old; then
1948 error "offline command failed; left in ~/.mrlog.old"
1952 info "no offline commands to run"
1957 info "offline mode enabled"
1959 info "remembering command: 'mr $@'"
1960 command="mr -d '$(pwd)' $MR_SWITCHES"
1962 command="$command '$w'"
1964 if [ ! -e ~/.mrlog ] || ! grep -q -F "$command" ~/.mrlog; then
1965 echo "$command" >> ~/.mrlog
1968 ed = echo "A horse is a horse, of course, of course.."
1969 T = echo "I pity the fool."
1970 right = echo "Not found."
1972 # vim:sw=8:sts=0:ts=8:noet